// This file is generated by kconfig_compiler_kf6 from camerasettings.kcfg.
// All changes you do to this file will be lost.
#ifndef CAMERASETTINGS_H
#define CAMERASETTINGS_H

#include <kconfigskeleton.h>
#include <QCoreApplication>
#include <QDebug>

class CameraSettings : public KConfigSkeleton
{
  Q_OBJECT
  public:

    static CameraSettings *self();
    ~CameraSettings() override;

    /**
      Set resolution
    */
    static
    void setResolution( const QSize & v )
    {
      if (v != self()->mResolution && !self()->isResolutionImmutable()) {
        self()->mResolution = v;
        Q_EMIT self()->resolutionChanged();
      }
    }

    Q_PROPERTY(QSize resolution READ resolution WRITE setResolution NOTIFY resolutionChanged)
    Q_PROPERTY(bool isResolutionImmutable READ isResolutionImmutable CONSTANT)
    /**
      Get resolution
    */
    static
    QSize resolution()
    {
      return self()->mResolution;
    }

    /**
      Is resolution Immutable
    */
    static
    bool isResolutionImmutable()
    {
      return self()->isImmutable( QStringLiteral( "resolution" ) );
    }

    /**
      Set cameraDeviceId
    */
    static
    void setCameraDeviceId( const QString & v )
    {
      if (v != self()->mCameraDeviceId && !self()->isCameraDeviceIdImmutable()) {
        self()->mCameraDeviceId = v;
        Q_EMIT self()->cameraDeviceIdChanged();
      }
    }

    Q_PROPERTY(QString cameraDeviceId READ cameraDeviceId WRITE setCameraDeviceId NOTIFY cameraDeviceIdChanged)
    Q_PROPERTY(bool isCameraDeviceIdImmutable READ isCameraDeviceIdImmutable CONSTANT)
    /**
      Get cameraDeviceId
    */
    static
    QString cameraDeviceId()
    {
      return self()->mCameraDeviceId;
    }

    /**
      Is cameraDeviceId Immutable
    */
    static
    bool isCameraDeviceIdImmutable()
    {
      return self()->isImmutable( QStringLiteral( "cameraDeviceId" ) );
    }

    /**
      Set cameraPosition
    */
    static
    void setCameraPosition( int v )
    {
      if (v != self()->mCameraPosition && !self()->isCameraPositionImmutable()) {
        self()->mCameraPosition = v;
        Q_EMIT self()->cameraPositionChanged();
      }
    }

    Q_PROPERTY(int cameraPosition READ cameraPosition WRITE setCameraPosition NOTIFY cameraPositionChanged)
    Q_PROPERTY(bool isCameraPositionImmutable READ isCameraPositionImmutable CONSTANT)
    /**
      Get cameraPosition
    */
    static
    int cameraPosition()
    {
      return self()->mCameraPosition;
    }

    /**
      Is cameraPosition Immutable
    */
    static
    bool isCameraPositionImmutable()
    {
      return self()->isImmutable( QStringLiteral( "cameraPosition" ) );
    }

    /**
      Set whiteBalanceMode
    */
    static
    void setWhiteBalanceMode( int v )
    {
      if (v != self()->mWhiteBalanceMode && !self()->isWhiteBalanceModeImmutable()) {
        self()->mWhiteBalanceMode = v;
        Q_EMIT self()->whiteBalanceModeChanged();
      }
    }

    Q_PROPERTY(int whiteBalanceMode READ whiteBalanceMode WRITE setWhiteBalanceMode NOTIFY whiteBalanceModeChanged)
    Q_PROPERTY(bool isWhiteBalanceModeImmutable READ isWhiteBalanceModeImmutable CONSTANT)
    /**
      Get whiteBalanceMode
    */
    static
    int whiteBalanceMode()
    {
      return self()->mWhiteBalanceMode;
    }

    /**
      Is whiteBalanceMode Immutable
    */
    static
    bool isWhiteBalanceModeImmutable()
    {
      return self()->isImmutable( QStringLiteral( "whiteBalanceMode" ) );
    }


    enum {
      signalResolutionChanged = 1,
      signalCameraDeviceIdChanged = 2,
      signalCameraPositionChanged = 3,
      signalWhiteBalanceModeChanged = 4
    };

  Q_SIGNALS:
    void resolutionChanged();

    void cameraDeviceIdChanged();

    void cameraPositionChanged();

    void whiteBalanceModeChanged();

  private:
    void itemChanged(quint64 signalFlag);

  protected:
    CameraSettings(QObject *parent = nullptr);
    friend class CameraSettingsHelper;


    // General
    QSize mResolution;
    static QSize defaultResolutionValue_helper();
    QString mCameraDeviceId;
    static QString defaultCameraDeviceIdValue_helper();
    int mCameraPosition;
    static int defaultCameraPositionValue_helper();
    int mWhiteBalanceMode;
    static int defaultWhiteBalanceModeValue_helper();

  private:
};

#endif

